// Generated by CoffeeScript 1.8.0
(function() {
  var describe, test;

  require('./index');

  test = function(bool, str) {
    return $.info((bool ? 'success' : 'error'), str);
  };

  describe = function(title, fn) {
    $.log('');
    $.info('info', title);
    return typeof fn === "function" ? fn() : void 0;
  };

  describe('$', function() {
    test($, '$ is ok');
    test($.type($) === 'object', '$ is an object');
    test($.type($.version) === 'string', '$.version is a string(' + $.version + ')');
    describe('error', function() {
      return test($["try"], '$.try is ok');
    });
    describe('basic', function() {
      describe('$.extend', function() {
        test($.parseString($.extend({}, {
          a: 1
        })) === $.parseString({
          a: 1
        }), '$.parseString($.extend({}, {a: 1})) == $.parseString({a: 1})');
        return test($.parseString($.extend({
          a: 1
        }, {
          b: 2
        })) === $.parseString({
          a: 1,
          b: 2
        }), '$.parseString($.extend({a: 1}, {b: 2})) == $.parseString({a: 1, b: 2})');
      });
      describe('$.type', function() {
        test($.type(false) === 'boolean', "$.type(false) == 'boolean'");
        test($.type('123') === 'string', "$.type('123') == 'string'");
        test($.type(123) === 'number', "$.type(123) == 'number'");
        test($.type({}) === 'object', "$.type({}) == 'object'");
        test($.type([]) === 'array', "$.type([]) == 'array'");
        test($.type(function() {}) === 'function', "$.type(->) == 'function'");
        test($.type(new Buffer('buffer')) === 'buffer', "$.type(new Buffer 'buffer') == 'buffer'");
        test($.type(null) === 'null', "$.type(null) == 'null'");
        test($.type(void 0) === 'undefined', "$.type(undefined) == 'undefined'");
        return test($.type(NaN) === 'NaN', "$.type(NaN) == 'NaN'");
      });
      describe('$.param', function() {
        return test($.param({
          a: 1,
          b: 2
        }) === 'a=1&b=2', "$.param({a: 1, b: 2}) == 'a=1&b=2'");
      });
      describe('$.trim', function() {
        return test($.trim(' trim test  ') === 'trim test', "$.trim(' trim test  ') == 'trim test'");
      });
      describe('$.now', function() {
        return test($.now === Date.now, '$.now == Date.now');
      });
      return describe('$.Callbacks', function() {
        var cb, e, f, i;
        cb = $.Callbacks();
        i = 0;
        f = function() {
          return i++;
        };
        e = function() {
          return i--;
        };
        test(cb.add && cb.remove && cb.has && cb.empty && cb.fire && cb.fired, 'has got methods: .add(), .remove(), .has(), .empty(), .fire() and .fired()');
        test(cb.list.length === 0, '.list length is 0, before .add()');
        cb.add(f);
        cb.add(f);
        test(cb.list.length === 2, '.add() is ok');
        cb.remove(f);
        test(cb.list.length === 1, '.remove() is ok');
        test(cb.has(f) && !cb.has(e), '.has() is ok');
        cb.empty();
        test(cb.list.length === 0, '.empty() is ok');
        test(cb.fired() === false, '.fired() returns false, before .fire()');
        cb.add(f).fire();
        test(i === 1, '.fire() is ok');
        return test(cb.fired() === true, '.fired() is ok');
      });
    });
    describe('parse', function() {
      describe('$.parseTime', function() {
        test($.parseTime($.now()) === '刚刚', "$.parseTime($.now()) == '刚刚'");
        test($.parseTime($.timeStamp($.now() - 5e3)) === '5秒前', "$.parseTime($.timeStamp($.now() - 5e3)) == '5秒前'");
        test($.parseTime($.timeStamp($.now() - 3e5)) === '5分钟前', "$.parseTime($.timeStamp($.now() - 3e5)) == '5分钟前'");
        return test($.parseTime($.timeStamp($.now() - 36e5)) === '1小时前', "$.parseTime($.timeStamp($.now() - 36e5)) == '1小时前'");
      });
      return describe('$.parseString', function() {
        return test($.parseString('123') === '123', "$.parseString('123') == '123'");
      });
    });
    describe('ajax', function() {});
    describe('promise', function() {});
    return describe('etc', function() {
      describe('$.log', function() {
        return test($.log === console.log, '$.log == console.log');
      });
      describe('$.info', function() {
        return test($.info, '$.info is ok');
      });
      describe('$.i', function() {
        return test($.i, '$.i is ok');
      });
      describe('$.timeStamp', function() {
        test(($.timeStamp($.now())) === $.now(), '($.timeStamp $.now()) == $.now()');
        test(($.type($.timeStamp('2012.12.21'))) === 'number', "($.type $.timeStamp '2012.12.21') == 'number'");
        return test(($.type($.timeStamp('1997.7.1 19:00'))) === 'number', "($.type $.timeStamp '1997.7.1 19:00') == 'number'");
      });
      describe('$.delay', function() {
        return test(1, 'not ready yet');
      });
      describe('$.rnd', function() {
        return test(($.type($.rnd())) === 'number', "($.type $.rnd()) == 'number'");
      });
      return describe('$.mid', function() {
        return test(($.type($.mid())) === 'string', "($.type $.mid()) == 'string'");
      });
    });
  });

}).call(this);
